#!/usr/bin/env python

import sys, base64

VERSIONEER_b64 = """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"""
newver = "0.24"

VERSIONEER_PEP518 = True

VERSIONEER = base64.b64decode(VERSIONEER_b64.encode('ASCII'))


# Stub overwritten by exec()
def setup_command(): ...

# Make versioneer usable via import
exec(VERSIONEER.decode(), globals())


def detect_installed_version() -> str:
    """Find version string in vendored versioneer

    Raises FileNotFoundError if missing.
    """
    with open("versioneer.py") as fobj:
        for i, line in enumerate(fobj):
            if line.startswith("# Version: "):
                return line[len("# Version: "):].strip()
            if i > 5:
                break
    return "unknown version"


def vendor():
    """Install versioneer into current directory"""
    try:
        oldver = detect_installed_version()
    except FileNotFoundError:
        pass
    else:
        print(f"replacing old versioneer.py ({oldver})")

    with open("versioneer.py", "wb") as fobj:
        fobj.write(VERSIONEER)
    print(f"versioneer.py ({newver}) installed into local tree")


def main():
    usage = "Usage: versioneer install [--vendor|--no-vendor]"
    if len(sys.argv) < 2 or len(sys.argv) > 3:
        print(usage)
        sys.exit(1)

    command = sys.argv[1]
    mode = "--vendor" if len(sys.argv) == 2 else sys.argv[2]

    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)
    elif command in ("help", "-help", "--help"):
        print(usage)
        sys.exit(0)
    elif command != "install" or mode not in ("--vendor", "--no-vendor"):
        print(usage)
        sys.exit(1)

    if mode == "--vendor":
        vendor()
        print("Now running 'versioneer.py setup' to install the generated files..")

    setup_command()


if __name__ == '__main__':
    main()
